/// <reference types="node" resolution-mode="require"/>
export interface AttributeInfo {
	required?: Boolean;
	unique?: Boolean;
	generate?: Function;
}
export interface Attribute {
	name: any;
  required?: Boolean;
	unique?: Boolean;
	generate?: Function;
}
export interface Attributes {
	[k: string]: AttributeInfo;
}
export interface Low {
	data: any;
	read: Function;
	write: Function;
}
export interface Model {
	init: (db: Low) => Promise<void>;
	create: (obj: Object) => Promise<void>;
	findAll: () => Promise<Array<Object>>;
	findOne: (query: Object) => Promise<Object | null>;
	find: (query: Object) => Promise<Array<Object>>;
	update: (query: Object, object: Object) => Promise<void>;
	remove: (query: Object) => Promise<void>;
}
export declare function newModel(attributes: Attributes, info: {tableName: string}): Model;